function [this, level] = get_level( this )

% [this, level] = get_level( this )


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if ~this.enabled, level = 0; return; end
if this.level >= 1, level = this.level; return; end


% read new inputs and adjust the trigger level
[this.input, val] = pop( this.input );
while ~isnan(val)
  
  if this.peak_scan_left > 0
    % still scanning peaks
    this.peak           = max( this.peak, val );
    this.peak_scan_left = this.peak_scan_left - 1;
    this.level          = 0;
    % if max peak was zero, trigger immediately
    if this.peak_scan_left == 0 & this.peak == 0, this.level = 1; end
  else
    % val == this.peak:                 level = 0.0
    % val == this.fraction * this.peak: level = 1.0
    this.level = max(0, (this.peak - val) / ((1 - this.fraction) * this.peak));
  end
  if this.level >= 1, break; end
  
  [this.input, val] = pop( this.input );
end


level = this.level;
return;
